/*
  alignlib - a library for aligning protein sequences

  $Id$

  Copyright (C) 2004 Andreas Heger
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


%module MultipleAlignment
%{
#include "../../src/alignlib.h"

using namespace AlignLib;

#include "../../src/Matrix.h"
#include "../../src/HelpersMultipleAlignment.h"
%}

class CountsMatrix {
    unsigned int getNumRows() const { return mRows; }
    unsigned int getNumCols() const { return mCols; }

};

%inline %{
    // Define a new Grid2d row class 
    struct MatrixRow {
	CountsMatrix * m;       // Grid
	int    row;             // Row number
	
	// These functions are used by Python to access sequence types (lists, tuples, ...)
	double __getitem__(int i) {
	    cout << "trying to access element " << row << " " << i << endl;
	    cout << (*m)[row][i] << endl;
            return (*m)[row][i];
	};
	void __setitem__(int i, int val) {
            (*m)[row][i] = val;
	};
    };
%}

// Now add a __getitem__ method to Grid2D to return a row
%addmethods CountsMatrix {

    MatrixRow __getitem__(int i) {
	cout << "trying to access row " << i<< " " << endl;
	MatrixRow r;
	r.m = self;
	r.row = i;
	return r;
    };
};

