/*
  alignlib - a library for aligning protein sequences

  $Id$

  Copyright (C) 2004 Andreas Heger
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

%module LogOddor
%{
#include "../../src/alignlib.h"

using namespace AlignLib;

#include "../../src/LogOddor.h"
#include "../../src/HelpersLogOddor.h"
%}

  /** Protocoll class for objects, convert frequencies into log-odds scores. Different
      log odds scorer use different background frequencies.
      
      This class is a protocol class and as such defines only the general interface.
      
      I know, I am not very creative when it comes to inventing names.
      
      @author Andreas Heger
      @version $Id: LogOddor.i,v 1.1.1.1 2002/07/01 17:15:20 heger Exp $
      @short protocol class for log-odders
      
  */
    
class LogOddor {

 public:
    // constructors and desctructors

    /** destructor */
    virtual ~LogOddor ();

    /** copy frequencies to a profile and while doing so, convert the frequencies into log-odd-scores */
    virtual void fillProfile( TYPE_PROFILE_COLUMN * profile, 
			      const TYPE_FREQUENCIES_COLUMN * frequencies,
			      const ALIGNANDUM_POSITION length ) const = 0;

};

/** factory functions */
%new const LogOddor * makeLogOddorUniform( CALCTYPE scale_factor = 1 );

%new const LogOddor * makeLogOddorDirichlet( CALCTYPE scale_factor = 1 );

/** gets the default LogOddor object */ 
 const LogOddor * getDefaultLogOddor();

/** sets the default LogOddor object */
 const LogOddor * setDefaultLogOddor( const LogOddor * logoddor);









