/*
  alignlib - a library for aligning protein sequences

  $Id$

  Copyright (C) 2004 Andreas Heger
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

%module Weightor
%{
#include "../../src/alignlib.h"

using namespace AlignLib;

#include "../../src/Weightor.h"
#include "../../src/HelpersWeightor.h"
%}

class Weightor {
 public:
    // constructors and desctructors

    /** destructor */
    virtual ~Weightor ();
    
    /** return a vector of weights for a multiple alignment. The ordering in the result will be the same 
	as in the multiple alignment. Note, that the caller has to delete the weights. */
    virtual TYPE_SEQUENCE_WEIGHTS * calculateWeights( const MultipleAlignment & src ) const = 0;

};

/** factor functions */
%new Weightor * makeNoWeightor();
%new Weightor * makeWeightorHenikoff();
%new Weightor * makeWeightorHenikoffKimmen();

/** gets the default Weightor object */ 
const Weightor * getDefaultWeightor();

/** sets the default Weightor object */
const Weightor * setDefaultWeightor( const Weightor * weightor);


