# alignlib - a library for aligning protein sequences
# 
# $Id$
# 
# Copyright (C) 2004 Andreas Heger
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
from Alignlib import *

a = makeSequence( "AAACCCAAA" )

b = makeAlignatumFromAlignandum( a )
print "Sequence:", a.Write()
print "Length:", a.getLength()
print "From:", a.getFrom()

alignator = makeFullDP( -10.0, -2.0 )

result = makeAlignataSet()

alignator.Align( a, a, result )

print "result\n", result.Write()
print "Score=", result.getScore()

print "Compressed: ", writeAlignataCompressed( result )
print "RSDB:", writeAlignataRSDB( result)
print "Table:", writeAlignataTable( result, 2, 0 )

alignment_a = makeAlignataSet()
alignment_b = makeAlignataSet()

fillAlignataExplicit( alignment_a, 1,  "AAA---CCCKKKAAA", 1, "AAAKKKCCCKKKA-A")
fillAlignataExplicit( alignment_b, 1,  "AAA---CCCKKKAAA", 1, "AAAKKKCCCKKKA-A")
print alignment_a.Write()
print alignment_b.Write()
print "Compressed and truncated:", writeAlignataCompressed( alignment_a, 5, 7 )


alignment_c = makeAlignataSet()
combineAlignata( alignment_c , alignment_a , alignment_b, 0 )
print alignment_c.Write()

alignment2 = makeAlignataSet()
fillAlignataCompressed( alignment2, 1, "+5-5+5", 1, "+5-5+5")
print "new ali", alignment2.Write()

alignment3 = makeAlignataSet()
fillAlignataCompressed( alignment3, 1, "+5-5", 1, "-5+5")
print "empty alignment", alignment3.Write()

print alignment3.mapRowToCol( 10 )

(x, y) = writeAlignataCompressed( alignment3, 0, 10)
print x, y

profile = makeProfile( "AAACCCAAAAAACCCAAAAAACCCAAA", 3 )
print profile.Write()
print "Writing binary profile"
writeProfileBinaryCounts( "test.profile", profile )

print "Writing binary profile as int"
writeProfileBinaryCountsAsInt( "test.profile2", profile )

print "profile read from binary counts"
new_profile = extractProfileBinaryCounts( "test.profile" )
print new_profile.Write()

print "profile read from binary counts as int"
new_profile_int = extractProfileBinaryCountsAsInt( "test.profile2" )
print new_profile_int.Write()




