# alignlib - a library for aligning protein sequences
# 
# $Id$
# 
# Copyright (C) 2004 Andreas Heger
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
from Alignlib import *

alignment_a2b = makeAlignataVector()
alignment_b2a = makeAlignataVector()
alignment_b2c = makeAlignataVector()

fillAlignataCompressed( alignment_a2b,  1, '+16-1+7-1+12-2+2-1+24-1+24-1+1-1+30-1+15', 1,  '+25-1+37-1+22-2+52' )
fillAlignataCompressed( alignment_b2a,  1, '+25-1+37-1+22-2+52', 1, '+16-1+7-1+12-2+2-1+24-1+24-1+1-1+30-1+15')

fillAlignataCompressed( alignment_b2c,  25, '+10-4+1-1+2-1+6-1+2-1+43-2+43', 26, '+24-1+2-1+36-2+51')
print "a2b\n", alignment_a2b.Write()
print "b2a\n", alignment_b2a.Write()
print "b2c\n", alignment_b2c.Write()

alignment_a2c = makeAlignataSet()
combineAlignata( alignment_a2c, alignment_b2a, alignment_b2c, 0)  # mode = RR

print alignment_a2c.Write()

#---- test combination
filterAlignataRemovePairs( alignment_a2b, alignment_b2a, 0)
print "a2b-filtered", alignment_a2b.Write()

filterAlignataRemovePairs( alignment_a2b, alignment_b2a, 1)       # mode = RC, should make empty alignment
print "a2b-filtered out", alignment_a2b.Write()

