# alignlib - a library for aligning protein sequences
# 
# $Id$
# 
# Copyright (C) 2004 Andreas Heger
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# testing iterative alignment

from Alignlib import *

a = makeSequence( "AAACCCCCCCAAACCCCCCCAAACCCCCCCAAA" )
b = makeSequence( "AAAKKKKKKKAAAKKKKKKKAAAKKKKKKKAAA" )

print "Sequence:", a.Write()
print "Length:", a.getLength()
print "From:", a.getFrom()
print "To:", a.getTo()

print "Sequence:", b.Write()
print "Length:", b.getLength()
print "From:", b.getFrom()
print "To:", b.getTo()

alignator = makeFullDP( -10.0, -2.0 )

result = makeAlignataSet()

performIterativeAlignment( result, a, b, alignator, 0.0)

print "result\n", result.Write()
print "Score=", result.getScore()



