# alignlib - a library for aligning protein sequences
# 
# $Id$
# 
# Copyright (C) 2004 Andreas Heger
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
from Alignlib import *

x2a = makeAlignataVector()
a2y = makeAlignataVector()

fillAlignataCompressed( x2a,
                        223, '+1343-1418+12-3+14',
                        259, '+12-1+21-1309+1447')
fillAlignataCompressed( a2y,
                        881, '+50-1+30-5+122-1+29-22+190-177+10-1+8-3+3-4+15-2+20-1+52-45+77-124+21-1+36-1+64',
                        758, '+64-3+61-1+91-18+58-154+207-1+50-38+69-53+247')

val = splitAlignataWithAlignata( x2a, a2y, CR)

fragments = map( lambda x: AlignataPtr(x), val)

for fragment in fragments:
    fragment.thisown = 1
    print fragment.Write()

val = splitAlignataWithAlignata( a2y, x2a, RC)

fragments = map( lambda x: AlignataPtr(x), val)

for fragment in fragments:
    fragment.thisown = 1
    print fragment.Write()



## a = makeAlignataVector()

## fillAlignataIdentity( a, 2, 3, 0 )
## fillAlignataIdentity( a, 10, 12, 0)
## fillAlignataIdentity( a, 20, 22, 0 )

## print "a", a.Write()

## b = makeAlignataVector()

## fillAlignataIdentity( b, 4, 5, 0 )
## fillAlignataIdentity( b, 23, 24, 0 )

## print "b", b.Write()

## val = splitAlignataWithAlignata( a, b, RR)

## fragments = map( lambda x: AlignataPtr(x), val)

## for fragment in fragments:
##     fragment.thisown = 1
##     print fragment.Write()


## val = splitAlignataWithAlignata( a, b, RC)

## fragments = map( lambda x: AlignataPtr(x), val)

## for fragment in fragments:
##     fragment.thisown = 1
##     print fragment.Write()


## val = splitAlignataWithAlignata( a, b, CR)

## fragments = map( lambda x: AlignataPtr(x), val)

## for fragment in fragments:
##     fragment.thisown = 1
##     print fragment.Write()


## val = splitAlignataWithAlignata( a, b, CC)

## fragments = map( lambda x: AlignataPtr(x), val)

## for fragment in fragments:
##     fragment.thisown = 1
##     print fragment.Write()

## val = splitAlignataWithAlignata( b, a, RR)

## fragments = map( lambda x: AlignataPtr(x), val)

## for fragment in fragments:
##     fragment.thisown = 1
##     print fragment.Write()


## val = splitAlignataWithAlignata( b, a, RC)

## fragments = map( lambda x: AlignataPtr(x), val)

## for fragment in fragments:
##     fragment.thisown = 1
##     print fragment.Write()


## val = splitAlignataWithAlignata( b, a, CR)

## fragments = map( lambda x: AlignataPtr(x), val)

## for fragment in fragments:
##     fragment.thisown = 1
##     print fragment.Write()


## val = splitAlignataWithAlignata( b, a, CC)

## fragments = map( lambda x: AlignataPtr(x), val)

## for fragment in fragments:
##     fragment.thisown = 1
##     print fragment.Write()


