# alignlib - a library for aligning protein sequences
# 
# $Id$
# 
# Copyright (C) 2004 Andreas Heger
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# testing iterative alignment
import sys
from Alignlib import *

a = makeSequence( "AAACCCAAACCCAAACCCAAACCCAAA" )
b = makeSequence( "AAAKKKAAAKKKAAAKKKAAAKKKAAA" )

print "Sequence:", a.Write()
print "Length:", a.getLength()
print "From:", a.getFrom()
print "To:", a.getTo()

print "Sequence:", b.Write()
print "Length:", b.getLength()
print "From:", b.getFrom()
print "To:", b.getTo()

alignator = makeAlignatorIdentity()

dots = makeAlignataMatrixRow()
fillAlignataIdentity( dots, 1, 3, 6 )
fillAlignataIdentity( dots, 7, 9, -6)

rescoreAlignment( dots, a, b)

print dots.Write()
 
fragmentor = makeFragmentorIterative( dots, 5.0, -1.0, -1.0)

sample = makeAlignataSet()

val = fragmentor.Fragment( a, b, sample )

fragments = map( lambda x: AlignataPtr(x), val)

print "length of fragments ", len(fragments)

for fragment in fragments:
    fragment.thisown = 1
    print fragment.Write()


    

