# alignlib - a library for aligning protein sequences
# 
# $Id$
# 
# Copyright (C) 2004 Andreas Heger
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# testing iterative alignment

from Alignlib import *

def TestMali( insert_gaps_row, insert_gaps_col, use_end_row, use_end_col):

    mali1 = makeMultipleAlignment()
    mali2 = makeMultipleAlignment()

    s1 = "ABCDEFGH"
    s2 = "STCDEUVGW"

    seq1 = makeAlignatumFromString(s1)
    seq1.thisown = 0
    mali1.addAlignatum( seq1 )
    seq1 = makeAlignatumFromString(s1)
    seq1.thisown = 0
    mali1.addAlignatum( seq1 )
    
    seq2 = makeAlignatumFromString(s2)
    seq2.thisown = 0
    mali2.addAlignatum( seq2 )
    seq2 = makeAlignatumFromString(s2)
    seq2.thisown = 0
    mali2.addAlignatum( seq2 )

    ali = makeAlignataSet()
    fillAlignataIdentity( ali, 3, 5, 0)
    ali.addPairExplicit( 7, 8, 0.0)

    mali = makeMultipleAlignment()
    mali.addMultipleAlignment( mali1)
    print mali.Write()
    
    mali.addMultipleAlignment( mali2, ali, 1,
                               insert_gaps_row,
                               insert_gaps_col,
                               use_end_row,
                               use_end_col)
    print mali.Write()



def TestAlignatum( insert_gaps_row, insert_gaps_col, use_end_row, use_end_col):


    s1 = "ABCDEFGH"
    s2 = "STCDEUVGW"

    seq1 = makeAlignatumFromString(s1)
    seq1.thisown = 0
    seq2 = makeAlignatumFromString(s2)
    seq2.thisown = 0
    
    mali = makeMultipleAlignment()
    mali.addAlignatum( seq1 )
    print mali.Write()
    
    ali = makeAlignataSet()
    fillAlignataIdentity( ali, 3, 5, 0)
    ali.addPairExplicit( 7, 8, 0.0)
    
    mali.addAlignatum( seq2, ali, 1,
                        insert_gaps_row,
                        insert_gaps_col,
                        use_end_row,
                        use_end_col)
    print mali.Write()

print "1100"
TestAlignatum( 1,1,0,0 )
TestMali( 1,1,0,0 )

print "1111"
TestAlignatum( 1,1,1,1 )
TestMali( 1,1,1,1 )

print "0110"
TestAlignatum( 0,1,1,0 )
TestMali( 0,1,1,0 )

