# alignlib - a library for aligning protein sequences
# 
# $Id$
# 
# Copyright (C) 2004 Andreas Heger
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
from Alignlib import *

alignment_a = makeAlignataSet()

fillAlignataIdentity( alignment_a, 1, 3, 0 )
alignment_c = alignment_a.getClone()
print "a", alignment_a.Write()
print "c", alignment_c.Write()

fillAlignataIdentity( alignment_a, 5, 6, -1 )

print "a", alignment_a.Write()
print "c", alignment_c.Write()

profile_a = makeProfile( "AAACCCAAAAAACCCAAAAAACCCAAA", 3 )
profile_b = makeProfile( "KKKDDDKKKKKKDDDKKKKKKDDDKKK", 3 )
print profile_a.Write()
print profile_b.Write()

addProfile2Profile( profile_a, profile_b, alignment_a)

print profile_a.Write()
print profile_b.Write()

substituteProfileWithProfile( profile_a, profile_b, alignment_a)

print profile_a.Write()
print profile_b.Write()

print "Rescaling"
rescaleProfileCounts( profile_a, 0.5 )
print profile_a.Write()

print "Normalizing"
normalizeProfileCounts( profile_a, 1.0 )
print "Profile A", profile_a.Write()


profile_c = makeProfile( "AAAACCCC", 2)
profile_c.Prepare()
print profile_c.Write()
normalizeProfileCounts( profile_c, 1.0 )
profile_c.Release()
profile_c.Prepare()
print profile_c.Write()

# rescoring alignments
rescoreAlignment( alignment_c, profile_a, profile_b )
print "rescoreAlignata", alignment_c.Write()

## preparation is not done automatically!
profile_a.Prepare()
print "Profile A", profile_a.Write()
profile_b.Prepare()

fillAlignataIdentity(alignment_c, 1, 9, 0)

##rescoreAlignmentPrivate( alignment_c, profile_c, profile_c )
##print "rescoreAlignata", alignment_c.Write()

rescoreAlignmentPrivate( alignment_c, profile_a, profile_a )
print "rescoreAlignata", alignment_c.Write()

