# alignlib - a library for aligning protein sequences
# 
# $Id$
# 
# Copyright (C) 2004 Andreas Heger
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
from Alignlib import *

def Test( data, row_result, col_result):

    a = makeAlignataVector()

    for d in data:
        a.addPairExplicit( d[0], d[1], float(d[2]))

    (row, col) = writeAlignataCompressed( a )

    if row != row_result or col!= col_result:
        print "--> failure"
        print "row=", row
        print "col=", col
        print a.Write()
        return 1
    else:
        print "--> success"
        return 0

tests = ( ( ( (4,4,1),
              (5,5,1),
              (6,6,1)),
            "+3", "+3" ),
          ( ( (4,4,1),
              (6,6,1)),
            "+2-1+1", "+1-1+2" ),
          ( ( (4,4,1),
              (5,6,1)),
            "+1-1+1", "+3" ),
          ( ( (4,4,1),
              (6,5,1)),
            "+3", "+1-1+1" ),
          )


i = 0
for data, row_result, col_result in tests:
    i += 1
    print "test %i" %i ,
    result != Test(data, row_result, col_result)

    










