/*
  alignlib - a library for aligning protein sequences

  $Id$

  Copyright (C) 2004 Andreas Heger
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include <iostream>
#include <iomanip>
#include "Alignata.h"

#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

using namespace std;

namespace AlignLib {

//--------------------------------------------------------------------------------------
Alignata::Alignata() {
}    

//--------------------------------------------------------------------------------------
Alignata::~Alignata () {
}

//--------------------------------------------------------------------------------------
Alignata::Alignata(const Alignata & src) {
}
   
std::ostream & operator<<( std::ostream & output, const Alignata & src) {
  src.Write( output );
  return output;
}

std::istream & operator>>( std::istream & input, Alignata & target) {
  target.Read( input );
  return input;
}

bool operator==( const RESIDUEPAIR & x, const RESIDUEPAIR & y) { return (x.mRow == y.mRow) && (x.mCol == y.mCol);}
bool operator!=( const RESIDUEPAIR & x, const RESIDUEPAIR & y) { return (x.mRow != y.mRow) || (x.mCol != y.mCol);}

std::ostream & operator<< (std::ostream & output, const RESIDUEPAIR & src) {
  output << setw(5) << src.mRow << " " << setw(5) << src.mCol << " " << setw(10) << setprecision(4) << src.mScore;
  return output;
}

} // namespace AlignLib
