/*
  alignlib - a library for aligning protein sequences

  $Id$

  Copyright (C) 2004 Andreas Heger
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#if HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef FRAGMENTOR_H
#define FRAGMENTOR_H 1

#include "alignlib.h"
#include <vector>

namespace AlignLib {

/**
   Base class for generating a list of fragments from two objects.
   
   @author Andreas Heger
   @version $Id: Fragmentor.h,v 1.1.1.1 2002/07/01 17:15:20 heger Exp $
   @short protocol class for fragmentors
*/ 

class Alignata;
class Alignandum;

typedef std::vector<Alignata*> FragmentVector;

class Fragmentor {
  /* class member functions-------------------------------------------------------------- */
 public:
    /* constructors and desctructors------------------------------------------------------- */
    /** empty constructor */
    Fragmentor(); 
    
    /** destructor */
    virtual ~Fragmentor ();

    /** copy constructor */
    Fragmentor( const Fragmentor & src);
    
    /** method for aligning two arbitrary objects */
    virtual FragmentVector * Fragment(const Alignandum *, const Alignandum *, Alignata *) = 0; 
    
};

}

#endif /* FRAGMENTOR_H */
