/*
  alignlib - a library for aligning protein sequences

  $Id$

  Copyright (C) 2004 Andreas Heger
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#if HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef HELPERS_ALIGNANDUM_H
#define HELPERS_ALIGNANDUM_H 1

#include "alignlib.h"
#include <math.h>

namespace AlignLib {
    
    /** Helper functions for class Alignandum:
	
	1. factory functions
	
	2. accessor functions for default objects
	
	3. convenience functions
    */

    /* -------------------------------------------------------------------------------------------------------------------- */
    /* 1. factory functions */


    /* -------------------------------------------------------------------------------------------------------------------- */
    /* 2. accessor functions for default objects */
  

    /* ----------------------------------------------------------------------------------------*/
    /* 3. convenience functions */
    
    /** get a random position in a sequence ranging from 1 to max */
    inline ALIGNANDUM_POSITION GetRandomPosition ( ALIGNANDUM_POSITION max ) {
      return (1+(ALIGNANDUM_POSITION)((double)max*rand()/(RAND_MAX+1.0)));
    }

    

}

#endif	/* HELPERS_ALIGNANDUM_H */
