/*
  alignlib - a library for aligning protein sequences

  $Id$

  Copyright (C) 2004 Andreas Heger
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "alignlib.h"
#include "LogOddor.h"
#include "ImplLogOddor.h"
#include "HelpersLogOddor.h"

namespace AlignLib {
  
  static const LogOddor * DEFAULT_LOGODDOR = makeLogOddorDirichlet();
  
  /** gets the default LogOddor object */ 
  const LogOddor * getDefaultLogOddor() {
    return DEFAULT_LOGODDOR;
  }

  /** sets the default LogOddor object */
  const LogOddor * setDefaultLogOddor( const LogOddor * logOddor ) {
    const LogOddor * t = DEFAULT_LOGODDOR;
    DEFAULT_LOGODDOR = logOddor;
    return t;
  }

} // namespace AlignLib
