/*
  alignlib - a library for aligning protein sequences

  $Id$

  Copyright (C) 2004 Andreas Heger
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#if HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef IMPL_ALIGNATOR_DUMMY_H
#define IMPL_ALIGNATOR_DUMMY_H 1

#include "alignlib.h"
#include "ImplAlignator.h"

namespace AlignLib {

  /** This alignator object is initialized with an alignment. No
      matter what the alignable objects are, a copy of the alignment
      is returned. You can use this for radar-like problems, where 
      you have a precalculated dot-matrix and you want to supply
      it to ALignatorDots.
      
      @author Andreas Heger
      @version $Id: ImplAlignatorDummy.h,v 1.1.1.1 2002/07/01 17:15:20 heger Exp $
      @short Return a pre-built alignment
      
  */

class Alignandum;

class ImplAlignatorDummy : public ImplAlignator {
 public:
    // constructors and desctructors

    /** default constructor */
    ImplAlignatorDummy  ( const Alignata * ali);
    
    /** copy constructor */
    ImplAlignatorDummy  (const ImplAlignatorDummy &);

    /** destructor */
    virtual ~ImplAlignatorDummy();

    /** method for aligning two arbitrary objects */
    virtual Alignata * Align(const Alignandum *, const Alignandum *, Alignata *);

 private:
    const Alignata * mAlignata;

};

}

#endif /* IMPL_DOTTOR_H */

